program DxLite;

uses
   Windows,
   Messages,
   LiteMain,
   LiteUtil;

const
   WM_IDLE            = (WM_USER + 100);
   CLASS_NAME : PChar = '__DxLite';
var
   hWindow    : HWnd;
   GameMain   : TLiteMain;

function WindowProc(hWindow: HWnd; uMsg : UINT; wParam : WPARAM; lParam : LPARAM): LRESULT; stdcall;
begin
   WindowProc := 0;

   case uMsg of
      WM_CREATE :
      begin
         GameMain := TLiteMain.Create(hWindow);
      end;
      WM_SHOWWINDOW :
      begin
      end;
      WM_DESTROY :
      begin
         GameMain.Free;
         PostQuitMessage(0);
         Exit;
      end;
      WM_KEYDOWN :
      begin
         if LoWord(wParam) = VK_ESCAPE then
            PostQuitMessage(0);
      end;
      WM_IDLE :
      begin
         GameMain.GameLoop;
      end;
   end;

   WindowProc := DefWindowProc(hWindow, uMsg, wParam, lParam);
end;

function MyRegisterClass(hInstance : HINST) : ATOM;
var
   WinClass : WNDCLASS;
begin

   FillChar(WinClass, sizeof(WinClass), 0);

   WinClass.style         := CS_HREDRAW or CS_VREDRAW;
   WinClass.lpfnWndProc   := @WindowProc;
   WinClass.cbClsExtra    := 0;
   WinClass.cbWndExtra    := 0;
   WinClass.hInstance     := hInstance;
   WinClass.hIcon         := LoadIcon(0, IDI_WINLOGO);
   WinClass.hCursor       := LoadCursor(0, IDC_ARROW);
   WinClass.hbrBackground := GetStockObject(LTGRAY_BRUSH);
   WinClass.lpszMenuName  := CLASS_NAME;
   WinClass.lpszClassName := CLASS_NAME;

   Result := RegisterClass(WinClass);
end;

procedure WinMain;
var
   uMsg    : TMsg;
begin

   if HPrevInst = 0 then begin
      if MyRegisterClass(HInstance) = 0 then
         Halt;
   end;

   hWindow := CreateWindow(CLASS_NAME, 'DxLite Project',
                           WS_OVERLAPPED or WS_CAPTION or WS_SYSMENU,
                           CW_USEDEFAULT, CW_USEDEFAULT,
                           640 + 2 * WIN_MOUSE_X_GAP,
                           480 + 2 * WIN_MOUSE_X_GAP + WIN_TITLE_HEIGHT,
                           0, 0, hInstance, nil);
   if hWindow = 0 then
      Halt;

(* Window    ʿ *)
   ShowWindow(hWindow, CmdShow);
   UpdateWindow(hWindow);
//*)
   while (TRUE) do begin
      if PeekMessage(uMsg, 0, 0, 0, PM_NOREMOVE) then begin
         if not GetMessage(uMsg, 0, 0, 0) then
            break;
         TranslateMessage(uMsg);
         DispatchMessage(uMsg);
      end
      else begin
         PostMessage(hWindow, WM_IDLE, 0, 0);
         WaitMessage;
      end;
   end;

   Halt(uMsg.wParam);
end;

begin
   WinMain;
end.

